diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 9765a92d1..7dbf69160 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -940,26 +849,30 @@ public class WorldRenderer {
                         double d5 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
                         double d6 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
                         float f11 = MathHelper.sqrt(d5 * d5 + d6 * d6) / (float) radiusEffect;
-                        tessellator.startDrawingQuads();
-                        float f12 = world.getLightBrightness(x, i3, z);
-                        if (this.mc.fullbright) f12 = 1.0f;
-                        glColor4f(f12, f12, f12, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
+                        float brightness;
+                        if (this.mc.fullbright) {
+                            brightness = 1.0f;
+                        } else {
+                            brightness = world.getLightBrightness(queryPos.set(x, i3, z));
+                        }
+                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
                         tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
                         tessellator.addVertexWithUV(x, k3, (double) z + 0.5D, 0.0F * f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV(x + 1, k3, (double) z + 0.5D, f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV(x + 1, i4, (double) z + 0.5D, f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV(x, i4, (double) z + 0.5D, 0.0F * f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
+
                         tessellator.addVertexWithUV((double) x + 0.5D, k3, z, 0.0F * f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV((double) x + 0.5D, k3, z + 1, f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV((double) x + 0.5D, i4, z + 1, f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
                         tessellator.addVertexWithUV((double) x + 0.5D, i4, z, 0.0F * f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
                         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-                        tessellator.draw();
                     }
                 }
-
             }
+            tessellator.draw();
         } else if (precipitation.getPrecipitationType() == IPrecipitation.Type.RAIN_LIKE) {
+            tessellator.startDrawingQuads();
             for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
                 for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
@@ -980,31 +893,36 @@ public class WorldRenderer {
                     }
                     float f2 = 1.0F;
                     if (j3 != l3) {
-                        this.random.setSeed((long) x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
-                        float f4 = (((float) (this.rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + this.random.nextFloat());
+                        this.random.setSeed((long) x * x * 3121 + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
+                        float f4 = (((float) (this.rendererUpdateCount + x * x * 3121 + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + this.random.nextFloat());
                         double d3 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
                         double d4 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
                         float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float) radiusEffect;
-                        tessellator.startDrawingQuads();
-                        float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
-                        if (this.mc.fullbright) f10 = 1.0f;
-                        glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
+
+                        float brightness;
+                        if (this.mc.fullbright) {
+                            brightness = 1.0f;
+                        } else {
+                            brightness = world.getLightBrightness(queryPos.set(x, world.getHeightBlocks(), z)) * 0.85F + 0.15F;
+                        }
                         tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
+                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
                         tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV(x + 1, l3, (double) z + 0.5D, f2, ((float) l3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV(x, l3, (double) z + 0.5D, 0.0F * f2, ((float) l3 * f2) / 4F + f4 * f2);
+
                         tessellator.addVertexWithUV((double) x + 0.5D, j3, z, 0.0F * f2, ((float) j3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV((double) x + 0.5D, j3, z + 1, f2, ((float) j3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV((double) x + 0.5D, l3, z + 1, f2, ((float) l3 * f2) / 4F + f4 * f2);
                         tessellator.addVertexWithUV((double) x + 0.5D, l3, z, 0.0F * f2, ((float) l3 * f2) / 4F + f4 * f2);
                         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-                        tessellator.draw();
                     }
                 }
-
             }
+            tessellator.draw();
         } else if (precipitation.getPrecipitationType() == IPrecipitation.Type.INVERTED_RAIN_LIKE) {
+            tessellator.startDrawingQuads();
             for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
                 blockedWeather:
                 for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
@@ -1025,15 +943,18 @@ public class WorldRenderer {
                     }
                     float f2 = 1.0F;
                     if (j3 != l3) {
-                        this.random.setSeed((long) x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
+                        this.random.setSeed((long) x * x * 3121 + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
                         float vOffset = (((float) (this.rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + this.random.nextFloat());
                         double d3 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
                         double d4 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
                         float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float) radiusEffect;
-                        tessellator.startDrawingQuads();
-                        float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
-                        if (this.mc.fullbright) f10 = 1.0f;
-                        glColor4f(f10, f10, f10, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
+                        float brightness;
+                        if (this.mc.fullbright) {
+                            brightness = 1.0f;
+                        } else {
+                            brightness = world.getLightBrightness(queryPos.set(x, world.getHeightBlocks(), z)) * 0.85F + 0.15F;
+                        }
+                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.weatherManager.getWeatherIntensity() - 0.1f) * world.weatherManager.getWeatherPower());
                         tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
                         tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F - vOffset * f2);
                         tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F - vOffset * f2);
@@ -1044,26 +965,17 @@ public class WorldRenderer {
                         tessellator.addVertexWithUV((double) x + 0.5D, l3, z + 1, f2, ((float) l3 * f2) / 4F - vOffset * f2);
                         tessellator.addVertexWithUV((double) x + 0.5D, l3, z, 0.0F * f2, ((float) l3 * f2) / 4F - vOffset * f2);
                         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-                        tessellator.draw();
                     }
                 }
-
             }
+            tessellator.draw();
         }
-
-
-        glEnable(GL11.GL_CULL_FACE);
-        glDisable(GL11.GL_BLEND);
-        glAlphaFunc(516, 0.1F);
+        GLRenderer.popFrame();
     }
 
     public void setupScaledResolution() {
-        glClear(256);
-        glMatrixMode(GL11.GL_PROJECTION);
-        glLoadIdentity();
-        glOrtho(0.0D, this.mc.resolution.getExactScaledWidthScreenCoords(), this.mc.resolution.getExactScaledHeightScreenCoords(), 0.0D, 1000D, 3000D);
-        glMatrixMode(GL11.GL_MODELVIEW);
-        glLoadIdentity();
-        glTranslatef(0.0F, 0.0F, -2000F);
+        GL41.glClear(GL41.GL_DEPTH_BUFFER_BIT);
+        this.mc.getGuiProjectionMatrix(GLRenderer.projectionM4f());
+        this.mc.getGuiViewMatrix(GLRenderer.viewM4f());
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
index 8186f835c..ca0b6cead 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
@@ -10,12 +10,12 @@ public class BlockColorDefault
     @Override
     public int getFallbackColor(int meta, int tintIndex)
     {
-        return 0xFFFFFF;
+        return 0xFFFFFFFF;
     }
 
     @Override
     public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex)
     {
-        return 0xFFFFFF;
+        return 0xFFFFFFFF;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index b9043ea79..8118e1a60 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -1,8 +1,9 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -22,11 +23,11 @@ public abstract class BlockModel<T extends BlockLogic>
     public BlockModel(final Block<T> block){
         this.block = block;
     }
-    public abstract boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
-    public abstract boolean renderOverbright(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
-    public abstract boolean renderNoCulling(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
-    public abstract boolean renderWithOverrideTexture(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate textureIndex);
-    public abstract void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate);
+    public abstract boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
+    public abstract boolean renderOverbright(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
+    public abstract boolean renderNoCulling(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
+    public abstract boolean renderWithOverrideTexture(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate textureIndex);
+    public abstract void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord);
 
     public abstract boolean shouldItemRender3d();
     public abstract @NotNull DisplayPos getItemDisplayPos(@NotNull String id);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
index 4ae60d49b..927065ffe 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -18,21 +17,16 @@ public class BlockModelAlgae<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
-        float brightness = 1.0f;
-        if (!LightmapHelper.isLightmapEnabled()) {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        } else {
-            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        }
+        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
 
         int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
         float red = (float) (color >> 16 & 0xff) / 255F;
         float green = (float) (color >> 8 & 0xff) / 255F;
         float blue = (float) (color & 0xff) / 255F;
 
-        tessellator.setColorOpaque_F(red * brightness, green * brightness, blue * brightness);
+        tessellator.setColorOpaque3f(red, green, blue);
         IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, worldSource.getBlockData(tilePos));
         renderBlocks.renderTopFace(tessellator, bounds, tilePos.x(), tilePos.y() - 0.1125, tilePos.z(), tex);
         renderBlocks.renderBottomFace(tessellator, bounds, tilePos.x(), tilePos.y() + 0.0125, tilePos.z(), tex);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index 2efffecb6..0bd3af191 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicAxisAligned;
@@ -20,7 +20,7 @@ public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStand
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int meta = worldSource.getBlockData(tilePos);
         Axis axis = BlockLogicAxisAligned.metaToAxis(meta);
         switch (axis) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
index fabeaf9fa..455c2be57 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicBasket;
 import net.minecraft.core.util.helper.Side;
@@ -19,7 +19,7 @@ public class BlockModelBasket<T extends BlockLogicBasket> extends BlockModelStan
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBd bounds = new AABBd(this.block.getBounds());
         // Render basket
         final float onePix = 1.0f / 16;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
index a3d4b4b01..2e37212dc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicBed;
@@ -29,7 +29,7 @@ public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
         AABBd bounds = new AABBd(this.block.getBoundsFromState(worldSource, tilePos));
         renderBlocks.enableAO = true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
index 5130dd287..b6a23d24e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -1,8 +1,9 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicBrazier;
 import net.minecraft.core.block.Blocks;
@@ -11,10 +12,8 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelBrazier<T extends BlockLogicBrazier>
     extends BlockModelStandard<T> {
@@ -27,9 +26,9 @@ public class BlockModelBrazier<T extends BlockLogicBrazier>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        tessellator.setColorOpaque_I(0xFFFFFF);
+        tessellator.setColorOpaque1i(0xFFFFFF);
 
         renderBlocks.enableAO = true;
         renderBlocks.cache.setupCache(this.block, worldSource, tilePos);
@@ -57,63 +56,42 @@ public class BlockModelBrazier<T extends BlockLogicBrazier>
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         AABBdc bounds = this.block.getBounds();
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-
-        GL11.glColor4f(brightness, brightness, brightness, alpha);
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.baseTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, -1.0D, 0.0D, this.baseTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 1.0D, this.sideTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, -1.0D, this.sideTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 1.0D, 0.0D, 0.0D, this.sideTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.sideTexture);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, -1.0D, 0.0D, 0.0D, this.sideTexture);
         tessellator.draw();
-
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
index 2bb322c01..cfeb4ec06 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
@@ -1,17 +1,15 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelCactus(Block<T> block) {
@@ -19,7 +17,7 @@ public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final float sidesOffset = 0.0625F;
 
         AABBd bounds = new AABBd(this.block.getBounds());
@@ -39,58 +37,40 @@ public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float r = (float) (color >> 16 & 0xff) / 255F;
-            float g = (float) (color >> 8 & 0xff) / 255F;
-            float b = (float) (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        }
-
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         AABBdc bounds = getBlockBoundsForItemRender();
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-
         final float sidesOffset = 0.0625F;
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
+        tessellator.setColor1i(getStandaloneTintColor(metadata));
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         tessellator.offsetTranslation(0.0F, 0.0F, sidesOffset);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
         tessellator.offsetTranslation(0.0F, 0.0F, -sidesOffset);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         tessellator.offsetTranslation(0.0F, 0.0F, -sidesOffset);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
         tessellator.offsetTranslation(0.0F, 0.0F, sidesOffset);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         tessellator.offsetTranslation(sidesOffset, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
         tessellator.offsetTranslation(-sidesOffset, 0.0F, 0.0F);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         tessellator.offsetTranslation(-sidesOffset, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
         tessellator.offsetTranslation(sidesOffset, 0.0F, 0.0F);
         tessellator.draw();
 
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 }
